/*
 * 机具费率调整申请
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class PosMachinesFeeChangeRecordController : BaseController
    {
        public PosMachinesFeeChangeRecordController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 机具费率调整申请列表

        /// <summary>
        /// 根据条件查询机具费率调整申请列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(PosMachinesFeeChangeRecord data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 根据条件查询机具费率调整申请列表

        /// <summary>
        /// 机具费率调整申请列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(PosMachinesFeeChangeRecord data, string UserIdMakerCode, string UserIdRealName, string PosUserIdMakerCode, string PosUserIdRealName, string SortSelect = "1", string StatusSelect = "2", int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("PosSn", "1"); //机具SN
            Fields.Add("MerNo", "1"); //商户号
            Fields.Add("Sort", "0"); //品牌


            string condition = " and Status >=-1";
            //创客编号
            if (!string.IsNullOrEmpty(UserIdMakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + UserIdMakerCode + "')";
            }
            //创客真实姓名
            if (!string.IsNullOrEmpty(UserIdRealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + UserIdRealName + "')";
            }
            //机具所属人创客编号
            if (!string.IsNullOrEmpty(PosUserIdMakerCode))
            {
                condition += " and PosUserId in (select PosUserId from UserForMakerCode where MakerCode='" + PosUserIdMakerCode + "')";
            }
            //机具所属人真实姓名
            if (!string.IsNullOrEmpty(PosUserIdRealName))
            {
                condition += " and PosUserId in (select PosUserId from UserForRealName where RealName='" + PosUserIdRealName + "')";
            }
            //品牌
            if (!string.IsNullOrEmpty(SortSelect))
            {
                condition += " and Sort = " + Convert.ToInt32(SortSelect);
            }
            if (!string.IsNullOrEmpty(StatusSelect))
            {
                if (Convert.ToInt32(StatusSelect) > 0)
                {
                    if (Convert.ToInt32(StatusSelect) == 1) condition += " and Status = 1";
                    if (Convert.ToInt32(StatusSelect) == 2) condition += " and Status = 0";
                    if (Convert.ToInt32(StatusSelect) == 3) condition += " and Status = -1";
                }
            }



            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("PosMachinesFeeChangeRecord", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic["UserIdRealName"] = userid_Users.RealName;
                dic.Remove("UserId");
                //机具所属人
                int PosUserId = int.Parse(function.CheckInt(dic["PosUserId"].ToString()));
                Users posuserid_Users = db.Users.FirstOrDefault(m => m.Id == PosUserId) ?? new Users();
                dic["PosUserIdMakerCode"] = posuserid_Users.MakerCode;
                dic["PosUserIdRealName"] = posuserid_Users.RealName;
                dic.Remove("PosUserId");
                //状态
                string Status = dic["Status"].ToString();
                if (Status == "0") dic["Status"] = "处理中";
                if (Status == "1") dic["Status"] = "成功";
                if (Status == "-1") dic["Status"] = "失败";
                //产品类型
                dic["Sort"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["Sort"].ToString()));

            }
            return Json(obj);
        }

        #endregion

        #region 增加机具费率调整申请

        /// <summary>
        /// 增加或修改机具费率调整申请信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加机具费率调整申请

        /// <summary>
        /// 增加或修改机具费率调整申请信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(PosMachinesFeeChangeRecord data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("UserId", data.UserId); //创客
            Fields.Add("ChangeFee", data.ChangeFee); //调整费率
            Fields.Add("PosSn", data.PosSn); //机具SN
            Fields.Add("MerNo", data.MerNo); //商户号
            Fields.Add("PosUserId", data.PosUserId); //机具所属人

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("PosMachinesFeeChangeRecord", Fields, 0);
            AddSysLog(data.Id.ToString(), "PosMachinesFeeChangeRecord", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改机具费率调整申请

        /// <summary>
        /// 增加或修改机具费率调整申请信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            PosMachinesFeeChangeRecord editData = db.PosMachinesFeeChangeRecord.FirstOrDefault(m => m.Id == Id) ?? new PosMachinesFeeChangeRecord();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改机具费率调整申请

        /// <summary>
        /// 增加或修改机具费率调整申请信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(PosMachinesFeeChangeRecord data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();

            Fields.Add("UserId", data.UserId); //创客
            Fields.Add("ChangeFee", data.ChangeFee); //调整费率
            Fields.Add("PosSn", data.PosSn); //机具SN
            Fields.Add("MerNo", data.MerNo); //商户号
            Fields.Add("PosUserId", data.PosUserId); //机具所属人

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("PosMachinesFeeChangeRecord", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "PosMachinesFeeChangeRecord", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除机具费率调整申请信息

        /// <summary>
        /// 删除机具费率调整申请信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "PosMachinesFeeChangeRecord", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("PosMachinesFeeChangeRecord", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "PosMachinesFeeChangeRecord", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("PosMachinesFeeChangeRecord", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "PosMachinesFeeChangeRecord", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("PosMachinesFeeChangeRecord", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("PosMachinesFeeChangeRecord", Sort, Id);

            AddSysLog(Id.ToString(), "PosMachinesFeeChangeRecord", "sort");
            return "success";
        }
        #endregion


        #region 导入费率调整结果
        /// <summary>
        /// 导入费率调整结果
        /// </summary>
        /// <param name="ExcelData"></param>
        public string ImportEnd(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);

            List<int> dnposIds = new List<int>();
            List<int> dnposIds2 = new List<int>();
            List<int> dnposIds3 = new List<int>();
            string userIds = "";
            string warning = "";

            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];
                string PosNo = dr[0].ToString(); // 机具Sn
                var Amount = decimal.Parse(dr[1].ToString()); // 调整费率
                int Kind = int.Parse(dr[2].ToString()); // 1 调升 2 调低(0.63) 3 调低(0.6)
                var pos = db.PosMachinesTwo.FirstOrDefault(m => m.PosSn == PosNo) ?? new PosMachinesTwo();
                var poschange = db.PosMachinesFeeChangeRecord.FirstOrDefault(m => m.PosId == pos.Id && m.ChangeFee == Amount) ?? new PosMachinesFeeChangeRecord();
                if ((pos.UpFeeFlag == 1 && pos.DownFeeFlag == 0) || (pos.UpFeeFlag == 1 && pos.DownFeeFlag == 1 && poschange.Status == 0))
                {
                    if (Kind < 2)
                    {
                        warning += PosNo + ",该机具调低费率数值或类型不正确或已经调整，请检查好后全部重新导入";
                    }
                    else
                    {
                        Dictionary<string, object> data = new Dictionary<string, object>();
                        pos.DownFeeFlag = 1;
                        pos.DownFeeDate = DateTime.Now;
                        pos.DownFeeMan = SysUserName + "_" + SysRealName;
                        pos.DownFee = Amount;
                        poschange.Status = 1;
                        db.SaveChanges();
                        dnposIds.Add(pos.Id);

                        if (Kind == 2) dnposIds2.Add(pos.Id);
                        if (Kind == 3) dnposIds3.Add(pos.Id);

                        if (!userIds.Contains(pos.BuyUserId.ToString()))
                        {
                            userIds += pos.BuyUserId + ",";
                        }
                    }
                }
                else
                {
                    warning += PosNo + ",该机具不符合调低条件，请检查好后全部重新导入";
                }
            }
            if (!string.IsNullOrEmpty(warning))
            {
                return "waning |" + warning;
            }
            string[] lists = userIds.TrimEnd(',').Split(new char[] { ',' });
            int times = lists.ToList().Count;
            if (dnposIds.Count > 0)
            {
                //调降
                for (int i = 0; i < times; i++)
                {
                    var UserId = lists[i];
                    var posInfo = db.PosMachinesTwo.Where(m => dnposIds.Contains(m.Id) && m.BuyUserId == Convert.ToInt32(UserId)).ToList();
                    string snhtml = "<div style='margin-bottom: .48rem;'>";
                    foreach (var items in posInfo)
                    {
                        var mer = db.PosMerchantInfo.FirstOrDefault(m => m.Id == items.BindMerchantId);
                        string Name = mer.MerchantName;
                        if (mer.BrandId == 2)
                        {
                            if (Name.Contains("-"))
                            {
                                Name = Name.Split('-')[1];
                            }
                            else if (Name.Contains("_"))
                            {
                                Name = Name.Split('_')[1];
                            }
                        }
                        var brand = db.KqProducts.FirstOrDefault(m => m.Id == items.BrandId);
                        snhtml += "<div style='margin-bottom: .48rem;'><div class='f16'>商户姓名：" + Name + "</div>";
                        snhtml += "<div class='f16'>机具品牌：" + brand.Name + "</div>";
                        snhtml += "<div class='f16'>SN：" + items.PosSn + "</div>";
                        if (dnposIds2.Contains(items.Id)) snhtml += "<div class='f16'>当前费率：0.6%</div>";
                        if (dnposIds3.Contains(items.Id)) snhtml += "<div class='f16'>当前费率：0.63%</div>";
                        snhtml += "<div class='f16'>费率调整时间：" + items.DownFeeDate.Value.ToString("yyyy-MM-dd HH:mm:ss") + "</div></div>";
                    }
                    snhtml += "</div>";
                    RedisDbconn.Instance.AddList("MsgPersonalQueue", Newtonsoft.Json.JsonConvert.SerializeObject(new MsgPersonal()
                    {
                        UserId = Convert.ToInt32(UserId), //创客
                        Title = "商户费率变更通知", //标题
                        Content = "<div class='f16' style='margin-bottom: .72rem'>您的商户刷卡交易费率已变更成功！</div>" + snhtml, //内容
                        Summary = "您的商户刷卡交易费率已变更成功！",
                        CreateDate = DateTime.Now,

                    }));
                }
            }
            AddSysLog("0", "PosMachinesTwoChange", "ImportEnd");
            return "success";
        }
        #endregion


        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.PosMachinesFeeChangeRecord.Add(new PosMachinesFeeChangeRecord()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "PosMachinesFeeChangeRecord", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(PosMachinesFeeChangeRecord data, string UserIdMakerCode, string UserIdRealName, string PosUserIdMakerCode, string PosUserIdRealName, string StatusSelect, string SortSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("PosSn", "1"); //机具SN
            Fields.Add("MerNo", "1"); //商户号
            Fields.Add("Sort", "0"); //品牌


            string condition = "";
            //创客编号
            if (!string.IsNullOrEmpty(UserIdMakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + UserIdMakerCode + "')";
            }
            //创客真实姓名
            if (!string.IsNullOrEmpty(UserIdRealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + UserIdRealName + "')";
            }
            //机具所属人创客编号
            if (!string.IsNullOrEmpty(PosUserIdMakerCode))
            {
                condition += " and PosUserId in (select PosUserId from UserForMakerCode where MakerCode='" + PosUserIdMakerCode + "')";
            }
            //机具所属人真实姓名
            if (!string.IsNullOrEmpty(PosUserIdRealName))
            {
                condition += " and PosUserId in (select PosUserId from UserForRealName where RealName='" + PosUserIdRealName + "')";
            }
            //品牌
            if (!string.IsNullOrEmpty(SortSelect))
            {
                condition += " and Sort = " + Convert.ToInt32(SortSelect);
            }
            if (!string.IsNullOrEmpty(StatusSelect))
            {
                if (Convert.ToInt32(StatusSelect) > 0)
                {
                    if (Convert.ToInt32(StatusSelect) == 1) condition += " and Status = 1";
                    if (Convert.ToInt32(StatusSelect) == 2) condition += " and Status = 0";
                    if (Convert.ToInt32(StatusSelect) == 3) condition += " and Status = -1";
                }
            }

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("PosMachinesFeeChangeRecord", Fields, "Id desc", "0", 1, 20000, condition, "PosSn,ChangeFee", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                var PosSn = dic["PosSn"].ToString();
                var ChangeFee = function.CheckNum(dic["ChangeFee"].ToString());
                dic.Add("Kind", "2");

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("PosSn", "机具SN");
            ReturnFields.Add("ChangeFee", "调整费率");
            ReturnFields.Add("Kind", "调整类型(2-调降)");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "PosMachinesFeeChangeRecord", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
